--
-- Copyright (C) 2005 dahua Technologies, All Rights Reserved.
-- 2006-4-25 15:54 Z:\wjj\ven\152\DAHUA\Install.lua
-- 2006-9-21  modified by zhongjl for new partition
--

-- Flash ĴСΪ128K
local flashSectorSize = 0x20000;

local Installer = {};
Installer.TotalSize      = 0;    -- ܵҪдFlashеݴС
Installer.InProgressSize = 0;	 -- пƽ
Installer.UpgradeSecurityVersion = "3.00";	 --а汾ϢҪֶ£user/data/hardware.luaеversionһ

-- ֪ͨϲӦóĽϢ
-- params:
--    
-- return:
--    
function Installer:notify()
	self.InProgressSize = self.InProgressSize + flashSectorSize;

	local progress = self.InProgressSize / self.TotalSize * 100;
	if(progress > 100) then
		progress = 100;
	end;
	progress = tonumber(string.format("%d", progress));

	-- ע÷ʽ,self::callback,ᵼ»ص
	self.callback(0x01, progress);
end

-- ̼汾Լ
-- params:
--    
-- return:
--   True-̼汾ݿ, False-̼汾ݣԭ򣬲ʧԭ
function Installer:checkFirmwareVersion()
	
	--豸ϳ汾,user/data/hardware.luaеversion
	local hardwareVersion =  Global.Hardware.board.version; 
	
	--ڰ汾"x.xx"
	if (hardwareVersion == "x.xx") then
		return true;
	end	
	
	--ȡ豸ϳİ汾ţת
	local sPos;
	local ePos;	
	local hardwareMainVerStr;
	local hardwareSubVerStr;
	sPos, ePos, hardwareMainVerStr, hardwareSubVerStr = string.find(hardwareVersion, "(%d+)%.(%d+)");		
	local hardwareMainVerNum = tonumber(hardwareMainVerStr);
	local hardwareSubVerNum = tonumber(hardwareSubVerStr);
	print("hardwareMainVerStr:%s hardwareSubVerStr:%s hardwareMainVerNum:%d hardwareSubVerNum:%d", hardwareMainVerStr, hardwareMainVerNum, hardwareMainVerNum, hardwareSubVerNum);	

	--ȡİ汾ţת
	local version = Installer.UpgradeSecurityVersion; 
	local mainVerStr;
	local subVerStr;
	sPos, ePos, mainVerStr, subVerStr = string.find(version, "(%d+)%.(%d+)");
	local mainVerNum = tonumber(mainVerStr);
	local subVerNum = tonumber(subVerStr);
	print("mainVerStr:%s subVerStr:%s mainVerNum:%d subVerNum:%d", mainVerStr, subVerStr, mainVerNum, subVerNum);	
	
	--İ汾ű>=豸hardware汾
	if ((mainVerNum > hardwareMainVerNum) or (mainVerNum == hardwareMainVerNum and subVerNum >= hardwareSubVerNum)) then
		return true;
	else
		return false, "Invalid version";
	end 
	return true;
end

-- ӦóṩϢжǷ
-- params:
--    
-- return:
--    ɹTrue, ʧܷFalseԼʧܵԭ
function Installer:preInstall()
	-- ҪЩ
	-- Ӳ汾 
	-- ԭİ汾ţ
	--
	local board = Global.Hardware.board;
	local hwproduct;
	local hwchannel;
	local hwversion;
	local hwfunction;

	print(string.format("Checking hardware information,board name:%s version:%s",
		board.name, board.version));
	if(board.name ~= "NVR4X-4KS2/L") then
		return false, "Invalid board";
	end
	if(board.version ~="3.00") then
		return false, "Invalid board version";
	end

	--ֱӴӲȡֵ
	--hwproductȡֵ: 2 -- LB; 3 -- LBN; 4 -- LB_ATM; 5 -- GBE; 6 -- LK; 7 -- LS
	--hwproductȡֵ: 2 -- IPC4X5; 3 -- A6; 4 -- A8; 5 -- IPVM;
	--hwchannelȡֵ: x -- x chans
	--hwfunctionȡֵ: 0 -- AUDIO; 1 -- MATRIX; 3 -- LOOP

	if(mtd.getinfo)then
		hwproduct,hwchannel,hwversion,hwfunction = mtd.getinfo();
		print(string.format("Checking hardware id info: product = %x; channel = %x; version = %x; function = %x",
			hwproduct,hwchannel,hwversion,hwfunction));
		if((hwproduct ~= 3) and (hwproduct ~= 4)) then
			print(string.format("product not match"));
			return false, "Invalid board";
		end
	end

	local isTest = Global.isFactoryTest;
	local vendor = Global.Vendor;
	if(vendor.VendorName) then
		print(string.format("Checking vendor information,vendor name:%s", vendor.VendorName));
		if(vendor.VendorName ~= 'DAHUA') then
			if(isTest == "true") then
				return true, "FactoryTestMode Upgrade to Public";
			end
			return false, "Invalid vendor";
		end
	end
	
	return true;
end

-- ɺĴ,ϵͳ
-- params:
--    
-- return:
--    
function Installer:postInstall()
end

-- Flash,ڲͬӦ,Ĵܲһ
-- params	:
-- part		: ,ʼλԼλ
-- filename	: еļ
-- return	: 
function Installer:updatePart(part, filename)
	local myfile = self.ZipArchive:open(filename);
	local write_times = 0;
	-- ļ򲻿,ҪԴ˲ֽ
	if(not myfile) then
		print(string.format("%s not exist", filename));
		return ;
	end

	local addr   = part.baseAddr;
	local endAddr= part.endAddr;
	local data;
	local fldata;
	local write_times1 = 0;
	
	myfile:seek("set");
	local file_length = myfile:seek("end") - 64;
	print(string.format("Start Update : %s ", filename));
	-- ǰ64ֽڵͷ,µ汾вҪԴ˽У
	myfile:seek("set", 64);
	while(addr < endAddr) do
		fldata = mtd.read(addr,flashSectorSize);
		data = myfile:read(flashSectorSize);    -- һFlashС
		-- if (fldata and data and (fldata ~= data)) then
		-- fldataΪյʱΪϵĳֱӲ

		if(data) then
			if((not fldata) or (data and (fldata ~= data))) then
				mtd.erase(addr);
				mtd.write(addr, data);
				write_times = write_times+1;
				fldata = mtd.read(addr,flashSectorSize);
				if((not fldata) or (data and (fldata ~= data))) then					
					mtd.erase(addr);
					mtd.write(addr, data);
					write_times1 = write_times1 + 1;
				end			
			end
		  self:notify();
		  addr   = addr   + flashSectorSize;
		else
		  addr = endAddr;
		end
	end
	
	if((filename == "u-boot.bin.img") and mtd.set_upgrade_info) then
		print(string.format("==>acccccmyfile %s ,base addr %x addr %x, length %d", filename, part.baseAddr, addr, file_length));
		mtd.set_upgrade_info(part.baseAddr, file_length);
	end
	
	print(string.format("==========> Write Times : %s  write_times1 : %s<==========", write_times, write_times1));
	myfile:close();
end

function Installer:InstallPlayer(filename)
	local myfile = self.ZipArchive:open(filename);

	-- ļ򲻿,ҪԴ˲ֽ
	if(not myfile) then
		return ;
	end

	--
	-- TODO:
	-- ԶݣͨIDEӿд뵽Ӳ
	--
end

--ѹimgļУ飬Уȷ1󷵻0
function Installer:crc32check( filename)
	local myfile = self.ZipArchive:open(filename);
	
	-- ļ򲻿(޴ļ),ҪԴ˲ֽ
	if(not myfile) then
		print(string.format("==>Installer:crc32check not myfile %s , no need to check", filename));
		return 1;
	end
	
	-- ӦóУӿ,У飬ֱӷسɹԼǰӦó
	if(not mtd.check_init) then
		print(string.format("==>Installer:crc32check not mtd.check_init, no need to check") );
		return 1	
	end	
	if(not mtd.crc32)then
		print(string.format("==>Installer:crc32check not mtd.crc32, no need to check"));
		return 1
	end
	
	local head = myfile:read(64);--64ֽڵͷ
	
	local filesize = 0;
	local filecrc32 = 0;
	print(string.format("==>Installermtd.check_init"));
	filesize, filecrc32 = mtd.check_init(head);-- ʼ
	print(string.format("==>Installer mtd.check_init over, filesize:%d filecrc:%x!", filesize, filecrc32));
	local checksum = 0;
	local readlen =0;
	local data;
	-- ݲּУ
	while (readlen < filesize) do
		data = myfile:read(flashSectorSize);
		--print(string.format("Installer check crc32:%x ------%x!", checksum, readlen) );
		if (filesize - readlen < flashSectorSize) then
			checksum = mtd.crc32(checksum, data, filesize - readlen)
		else
			checksum = mtd.crc32(checksum, data, flashSectorSize)
		end
		readlen = readlen + flashSectorSize;
	end

	if (checksum ~= filecrc32) then
		print(string.format("==>error: Installer check (%s)crc32 error:%x ------%x!", filename, checksum, filecrc32));
		return 0;
	end
	print(string.format("==>correct: Installer check(%s) crc32 correct:%x ------%x!", filename, checksum, filecrc32));
	return 1;
end


function Installer:do_cmd(cmd)
	local ret;
	if (mtd.run_cmd) then
		ret = mtd.run_cmd(cmd);
		print(string.format("Installer:do_cmd mtd.run_cmd cmd=%s ret=%d \n", cmd, ret));
	else
		ret = os.execute(cmd);
		print(string.format("Installer:do_cmd os.execute cmd=%s ret=%d \n", cmd, ret));
	end
	return ret == 0;
end
-- 
-- params:
--    
-- return:
--    ɹTrue,ʧܷFlaseԼԭ
function Installer:execute()
	local flashPartions =
	{
		param		= { baseAddr = 0x00000000  , endAddr = 0x00140000 },	--// 1.25 M GCIS
		boot	    = { baseAddr = 0x00140000  , endAddr = 0x00540000 },	--// 4M uboot
		env		    = { baseAddr = 0x00540000  , endAddr = 0x00740000 },	--// 2M env
		romfs		= { baseAddr = 0x00740000  , endAddr = 0x03780000 },	--// 48.25M romfs
		custom		= { baseAddr = 0x03780000  , endAddr = 0x03980000 },	--// 2M custom
		web	        = { baseAddr = 0x03980000  , endAddr = 0x04880000 },	--// 15M web
		logo        = { baseAddr = 0x04880000  , endAddr = 0x04A80000 },	--// 2M logo
		dgs			= { baseAddr = 0x04A80000  , endAddr = 0x04B00000 },	--// 512k dgs
		algorithm	= { baseAddr = 0x04B00000  , endAddr = 0x07400000 },	--// 41M ext_usr
		config_fw	= { baseAddr = 0x07400000  , endAddr = 0x07600000 },	--// 10M config_fw
		config		= { baseAddr = 0x07600000  , endAddr = 0x08000000 },	--// 2M config
	}

	-- self.ZipArchive ⲿ,ûóӦе
	assert(self.ZipArchive);
	local zfile = self.ZipArchive;

	local ret, info = self:preInstall();
	if(not ret) then
		return false, info;
	end

	-- ҪļСԼӡļ嵥
	local TotalSize = 0;
	print("==>Files in archive");
	for file in zfile:files() do
		print(file.filename);
		TotalSize = TotalSize + file.uncompressed_size;
	end
	self.TotalSize  = TotalSize;     -- ܵļС
	
	mtd.init();

	if (1 ~= (self:crc32check("minios-x.squashfs.img"))
		or 1 ~= (self:crc32check("param.bin.img"))
	    or 1 ~= (self:crc32check("u-boot.bin.img"))
	    or 1 ~= (self:crc32check("uImage.img"))
	    or 1 ~= (self:crc32check("romfs-x.squashfs.img")) 
	    or 1 ~= (self:crc32check("algorithm-x.squashfs.img")) 
	    or 1 ~= (self:crc32check("web-x.squashfs.img"))		
	    or 1 ~= (self:crc32check("custom-x.squashfs.img"))
	    or 1 ~= (self:crc32check("logo-x.squashfs.img"))) then
		--or 1 ~= (self:crc32check("user-x.squashfs.img"))
		print("==>Upgrade: crc32check error!");
		return false;
	end

    local state = 0;
	if (mtd.getenv) then	
		state = mtd.getenv("update_state");
	end
	if (state ~= 2) then
		if (mtd.setenv) then
			mtd.setenv("update_state", "1");
		end
		self:updatePart(flashPartions["web"],	"minios-x.squashfs.img");
	end	
	if (mtd.setenv) then
		mtd.setenv("update_state", "2");
	end
	
	--self:updatePart(flashPartions["kernel"], "uImage.img");
	self:updatePart(flashPartions["param"], "param.bin.img");
	--mtd.saveenv();
	self:updatePart(flashPartions["romfs"],	"romfs-x.squashfs.img");
	self:updatePart(flashPartions["algorithm"], "algorithm-x.squashfs.img");
	
	if (mtd.setenv) then
		mtd.setenv("update_state", "3");
	end	
	
	self:updatePart(flashPartions["custom"], "custom-x.squashfs.img");
	-- 豸logoĬϲӦóãEraseLogoΪⲿ
--	if (self.EraseLogo) then
--		print(string.format("==>correct: Installer EraseLogo executed!"));
--		self:updatePart(flashPartions["logo"],		"logo-x.squashfs.img");
--	end
	-- 豸logoĬϲӦóãEraseLogoΪⲿ
	-- δô˱־logoд
	if ((type(self.EraseLogo) == 'nil') or self.EraseLogo) then
		print(string.format("==>correct: Installer EraseLogo executed!"));
		self:updatePart(flashPartions["logo"],		"logo-x.squashfs.img");
	end  
	print(string.format("==>correct: Installer EraseLogo%s!", tostring(self.EraseLogo)));
	self:postInstall();
	
	self:updatePart(flashPartions["web"],		"web-x.squashfs.img");
	self:updatePart(flashPartions["boot"], "u-boot.bin.img");
	if (mtd.setenv) then
		mtd.setenv("update_state", "0");
	end	
	
	print("==>Upgrade finished.");
	return true;
end

return Installer;
